#########################
##     BRICK FIGHT     ##
##      MINI GAME      ##
#########################

#Author: Chaps79
#Additional Credits:
#   LG_Legacy for Throwable Bricks
#   Mustin07 for Arena design
#   Obi85 for Arena design

#Date of first Publication: 21 Sep 2024
#Native Version: Paper 1.21.1 Denizen 1.3.1 B7066
#Current Versions: Paper 1.21.1 Denizen 1.3.1 B7074

#Build: beta      | 21 Sep 2024
#       1.21.1 v1 | 10 Oct 2024
#       1.21.1 v2 | 16 Oct 2024

#Trailer: https://www.youtube.com/watch?v=dB9AkviVdmQ

#Permissions:
#   Basic User: None Required
#   Moderator Perms: dscript.brickfight.mod
#       Mods have permission to kick players from game.
#   Admin Perms: dscript.brickfight.admin
#       Admin perms allow entry into the arena via the Admin Entry sign.
#       Admins can use non-bf commands while in bf.
#       Admins will be placed in creative mode post-game.
#       Admins can break & place blocks inside the arena.
#       Perms to Admin commands below.
#   Manager Perms: dscript.brickfight.manager
#       Manager perms allow use of the setup wand to create the arena.
#       Perms to Manager commands below.

#Commands:
#   Brick fight commands begin with /brickfight or alias /bf
#
#   Basic User:
#       ./bf leave - leave the minigame
#   Mod:
#       ./bf kick <player.name> - kicks specified player from the minigame
#   Admin:
#       ./bf get_inventory <player.name> - replaces the linked Admin's inventory with specified player's inventory. This can be used to
#                                          restore player inventory in case of an unexpected glitch.
#       ./bf reset - rebuilds the arena from the saved schematic
#   Manager:
#       ./bf setup - opens the setup GUI
#       ./bf show_arena - highlights the boundaries of the arena, bases, lobbies, signboard, and forges
#       ./bf overwrite_schem - overwrites current bf_arena schematic. This can be used to make changes to the
#                              arena after setup is complete.

#################
##    ITEMS    ##
#################

masonry_brick:
    type: item
    material: brick
    display name: <&f>Masonry Brick

iron_brick:
    type: item
    material: iron_ingot
    display name: <&f>Iron Brick

explosive_brick:
    type: item
    material: nether_brick
    display name: <&f>Explosive Brick

bf_team_selector:
    type: item
    debug: false
    material: leather_chestplate
    display name: Choose your <&5>Team
    mechanisms:
        color: white
        hides: all

bf_leave_selector:
    type: item
    debug: false
    material: nether_star
    display name: <&c>Leave Game
    mechanisms:
        hides: all

bf_leather_helmet:
    type: item
    debug: false
    material: leather_helmet
    display name: <&e>Hard Hat
    mechanisms:
        unbreakable: true
        hides: all
    lore:
    - <&6>Price: <&f>40 points
    - <&7>20% concussion reduction
    - <&7>+1 armor
    flags:
      bf: bf_leather_helmet
      cost: 40

bf_netherite_helmet:
    type: item
    debug: false
    material: netherite_helmet
    display name: <&6>Kevlar
    mechanisms:
        unbreakable: true
        hides: all
    lore:
    - <&6>Price: <&f>100 points
    - <&7>60% concussion reduction
    - <&7>+3 armor
    flags:
      bf: bf_netherite_helmet
      cost: 100

bf_helmets_complete:
    type: item
    debug: false
    material: netherite_helmet
    display name: <&6>Kevlar
    mechanisms:
        unbreakable: true
        hides: all
        enchantments: protection,1
    lore:
    - <&a>Complete!

bf_leggings:
    type: item
    debug: false
    material: leather_leggings
    display name: <&f>Pants
    mechanisms:
        unbreakable: true
        color: white
        hides: all

bf_speed_leggings:
    type: item
    debug: false
    material: leather_leggings
    display name: <&6>Speed Pants
    mechanisms:
        unbreakable: true
        color: yellow
        hides: all
    lore:
    - <&6>Price: <&f>80 points
    - <&7>Speed 1
    flags:
      bf: bf_speed_leggings
      cost: 80

bf_leggings_complete:
    type: item
    debug: false
    material: leather_leggings
    display name: <&6>Speed Pants
    mechanisms:
        unbreakable: true
        color: yellow
        hides: all
        enchantments: protection,1
    lore:
    - <&a>Complete!

bf_blue_chestplate:
    type: item
    debug: false
    material: leather_chestplate
    flags:
        team: blue
    display name: <&9>Blue Team
    mechanisms:
        unbreakable: true
        color: blue
        hides: all

bf_blue_boots:
    type: item
    debug: false
    material: leather_boots
    display name: <&9>Blue Team
    mechanisms:
        unbreakable: true
        color: blue
        hides: all

bf_red_chestplate:
    type: item
    debug: false
    material: leather_chestplate
    display name: <&c>Red Team
    flags:
        team: red
    mechanisms:
        unbreakable: true
        color: red
        hides: all

bf_red_boots:
    type: item
    debug: false
    material: leather_boots
    display name: <&c>Red Team
    mechanisms:
        unbreakable: true
        color: red
        hides: all

bf_strong_arm:
    type: item
    debug: false
    material: magma_cream
    display name: <&6>Strong Arm
    lore:
    - <&6>Price: <&f>100 points
    - <&7>+50% distance
    flags:
      bf: bf_strong_arm
      cost: 100

bf_strong_arm_complete:
    type: item
    debug: false
    material: magma_cream
    display name: <&c>Strong Arm
    lore:
    - <&a>Complete!
    mechanisms:
      enchantments: mending,1
      hides: all

bf_forge:
    type: item
    debug: false
    material: furnace
    display name: <&6>Forge Upgrade
    lore:
    - <&6>Price: <&f>70 points
    - <&7>+50% forge drops
    flags:
      bf: bf_forge
      cost: 70

bf_forge_complete:
    type: item
    debug: false
    material: furnace
    display name: <&c>Forge Upgrade
    lore:
    - <&a>Complete!
    mechanisms:
      enchantments: mending,1
      hides: all

bf_gapple:
    type: item
    debug: false
    material: golden_apple
    display name: <&6>Gapple
    lore:
    - <&6>Price: <&f>10 points
    flags:
      bf: gapple
      cost: 10

#################
##   CONFIGS   ##
#################

bf_config:
    type: data
    debug: false
    #Points earned for hitting a player. Each brick type has a different point base.
    masonry_hit: 3
    iron_hit: 6
    explosive_hit: 4
    #Concussion multiplier (lower number means less likely to get concussion)
    leather_multiplier: 0.8
    netherite_mulitplier: 0.4
    #Max 14 recommended for the optional schematic provided with this script.
    max_players: 14
    #Min should be at least 2. Can reduce to 1 for testing purposes but the debug will show errors.
    min_players: 2
    #Game time in seconds
    timer: 900
    #Brick Types
    bricks:
        # normal brick
        - masonry_brick
        # heavy brick that does double damage to players; greater probability of causing concussion; shorter throw distance
        - iron_brick
        # explodes upon impact. does more damage to players; breaks glass in a double-sized radius
        - explosive_brick
    #Points are used for purchasing upgrades. Increase start points if you want a faster game.
    start_points: 20
    #Lives = Total Players + start_lives_addend
    start_lives_addend: 4

bf_flag_maps:
    #For Reference Only. This data script is not called upon.
    type: data
    debug: false
    server_flags:
        bf:
            in_session: true
            blue:
                points: (number)
                lives: (number)
                forge: true
                strong_arm: true
                leather_helm: true
                neth_helm: true
                speed_leggings: true
            red:
                points: (number)
                lives: (number)
                forge: true
                strong_arm: true
                leather_helm: true
                neth_helm: true
                speed_leggings: true
    noted_locations:
        - bf_admin_spawn
        - bf_blue_spawn
        - bf_red_spawn
    location_flags:
        bf:
            forge:
              - blue
              - red
            death: true
    entity_flags:
        bf:
            brick:
                - masonry_brick
                - iron_brick
                - explosive_brick
            shop:
                - blue
                - red
    item_flags:
        bf: (item name)
        cost: (cost to purchase)
    player_flags:
        bf:
            concussion: true
            team:
                - blue
                - red
            pregame: true
            entering: true
            playing: true
            spectator: true
            invulnerable: true
            admin: true
        bf_postgame: true

#################
##    TASKS    ##
#################

bf_bossbar_task:
    type: task
    debug: false
    script:
    - define game_duration <script[bf_config].data_key[timer]>
    - define progress <server.flag[bf.timer].div[<[game_duration]>]>
    - define time <server.flag[bf.timer]>
    - bossbar auto bf_bossbar players:<server.online_players_flagged[bf]> "title:<&6><&l>Timer - <&f><&l><[time]>" progress:<[progress]> color:white
    - flag server bf.timer:--
    - if <server.flag[bf.timer]> <= 0:
      - run bf_end_task

bf_sidebar_task:
    type: task
    debug: false
    script:
    - define red_players <server.online_players_flagged[bf.team.red].size>
    - define blue_players <server.online_players_flagged[bf.team.blue].size>
    - define blue_lives <element[<&9>●].repeat[<server.flag[bf.blue.lives]>]>
    - define red_lives <element[<&c>●].repeat[<server.flag[bf.red.lives]>]>
    - foreach <server.online_players_flagged[bf.playing]> as:team_check:
        - define team blue if:<[team_check].has_flag[bf.team.blue]>
        - define team red if:<[team_check].has_flag[bf.team.red]>
        - define points <server.flag[bf.<[team]>.points]>
        - sidebar set "title:<&6><&l>Brick Fight" "values:<&d>   An ObiWorld Original||<&6>Team: <&color[<color[<[team]>]>]><[team].to_sentence_case>||<&f>Players: <&9><&l><[blue_players]> <&f><&l>/ <&c><&l><[red_players]>||<&9>Lives: <[blue_lives]>|<&c>Lives: <[red_lives]>||<&6>Team Points: <&f><[points]>" players:<[team_check]>

bf_countdown_task:
    type: task
    debug: false
    script:
    - playsound <[bf_pregamers]> sound:block_note_block_harp pitch:1
    - wait 1s
    - define bf_pregamers <server.online_players_flagged[bf.pregame]>
    - define num <[bf_pregamers].size>
    - if <[num]> < <[min_players]>:
        - actionbar "<&6>Stopping Countdown" targets:<[bf_pregamers]>
        - playsound <[bf_pregamers]> sound:entity_player_burp pitch:0.8
        - stop

bf_loot_task:
    type: task
    debug: false
    script:
    - define num_players <server.online_players_flagged[bf.playing].size>
    # Number of forge drops increases with number of players
    - define num_drops <[num_players].mul[0.3].round_up>
    # Forge upgrade will increase drop numbers
    - define blue_drops <[num_drops].mul[1.5].round_up> if:<server.has_flag[bf.blue.forge]>
    - define blue_drops <[num_drops]> if:!<server.has_flag[bf.blue.forge]>
    - define red_drops <[num_drops].mul[1.5].round_up> if:<server.has_flag[bf.red.forge]>
    - define red_drops <[num_drops]> if:!<server.has_flag[bf.red.forge]>
    # Determine brick type to be dropped.
    - if <util.random_chance[5]>:
      - define brick_type iron_brick
    - if <util.random_chance[5]>:
      - define brick_type explosive_brick
    - else:
      - define brick_type masonry_brick
    - drop <[brick_type]> <location[bf_forge_blue].above[0.2]> speed:0 quantity:<[blue_drops]>
    - drop <[brick_type]> <location[bf_forge_red].above[0.2]> speed:0 quantity:<[red_drops]>

bf_end_task:
    type: task
    debug: false
    script:
    - ratelimit server 10s
    - define in_bf <server.online_players_flagged[bf]>
    - define config <script[bf_config].data_key[]>
    # check timer before unflagging the server
    - if <server.flag[bf.timer]> <= 0:
        - title "title:<&6>Time Expired!" targets:<[in_bf]>
        - playsound <[in_bf]> sound:entity_elder_guardian_curse
    - if <server.flag[bf.timer]> > 0:
      - if <server.flag[bf.red.lives]> <= 0 || <server.online_players_flagged[bf.team.red].size> == 0:
        - define win_team blue
      - if <server.flag[bf.blue.lives]> <= 0 || <server.online_players_flagged[bf.team.blue].size> == 0:
        - define win_team red
      - wait 5t
      - title "title:<&color[<color[<[win_team]>]>]><[win_team].to_sentence_case> <&f>Wins!" targets:<[in_bf]>
      - playsound <[in_bf]> sound:entity_wither_death
    # unflag the server to prevent brickfight event scripts from running
    - flag server bf:!
    # wait for queued scripts to complete before removing info bars
    - wait 4t
    - sidebar remove players:<[in_bf]>
    - bossbar remove bf_bossbar players:<[in_bf]>
    # give players time to read the title message & give dead players time to respawn before exiting.
    - wait 4s
    # tp spectators out of arena
    - foreach <server.online_players_flagged[bf.spectator]> as:spectator:
        - flag <[spectator]> bf:!
        - teleport <[spectator]> <location[bf_main_lobby_spawn]>
        - adjust <[spectator]> gamemode:creative if:<[spectator].has_permission[dscript.brickfight.admin]>
        - adjust <[spectator]> gamemode:survival if:!<[spectator].has_permission[dscript.brickfight.admin]>
        - wait 1t
    # clear dropped bricks from forges and player death locations. (bf.forge and bf.death)
    - foreach <cuboid[bf_arena].blocks_flagged[bf]> as:drops:
        - remove <[drops].find_entities[item].within[2]>
    # remove death location flag
    - flag <cuboid[bf_arena].blocks_flagged[bf.death]> bf:!
    # reset base chests
    - inventory clear d:bf_red_chest
    - inventory clear d:bf_blue_chest
    - heal <[in_bf]>
    - playsound <[in_bf]> sound:entity_enderman_teleport
    - flag <server.online_players_flagged[bf.playing]> bf_postgame expire:20s
    - adjust <[in_bf]> remove_effects
    # unflag and teleport the players as individuals
    - foreach <server.online_players_flagged[bf.playing]> as:tp:
        - teleport <[tp]> <location[bf_main_lobby_spawn]>
        # reset gamemode in accordance with player permissions.
        - adjust <[tp]> gamemode:creative if:<[tp].has_permission[dscript.brickfight.admin]>
        - adjust <[tp]> gamemode:survival if:!<[tp].has_permission[dscript.brickfight.admin]>
        # this sections assumes server has EssentialsX loaded. Change permission nodes to match your server, if desired.
        - adjust <[tp]> can_fly:true if:<[tp].has_permission[essentials.fly]>
        - adjust <[tp]> fly_speed:0.15 if:<[tp].has_permission[essentials.speed.fly]>
        - flag <[tp]> bf:!
        - wait 3t
    # reset the arena. narrate progress to server operators
    - if !<schematic.list.contains_single[bf_schematic]>:
      - narrate "Loading Schematic..." targets:<server.online_ops>
      - ~schematic load name:bf_schematic
    - narrate "Rebuilding Arena..." targets:<server.online_ops>
    - ~schematic paste name:bf_schematic <cuboid[bf_arena].center> entities
    - narrate Done! targets:<server.online_ops>
    # reset lobby sign
    - define num <server.online_players_flagged[bf.pregame].size>
    - define max_players <[config.max_players]>
    - sign type:automatic "<&e><&l>Brick Fight|<&a>Ready|<&a>[Click to Join]|<&b><&l><[num]> / <[max_players]>" <location[bf_sign]>
    # one final purge of bf flag in case of stale data (due to being killed after the game ended but before being deflagged)
    - wait 2t
    - flag <server.online_players_flagged[bf]> bf:!

bf_leave_task:
    type: task
    debug: false
    script:
    - define config <script[bf_config].data_key[]>
    - playsound <player> sound:entity_enderman_teleport
    - if <player.has_flag[bf.pregame]>:
        - flag <player> bf:!
        - teleport <location[bf_main_lobby_spawn]>
        - inventory set o:bf<player.uuid>
        - define num <server.online_players_flagged[bf.pregame].size>
        - sign type:automatic material:dark_oak_sign "<&e><&l>Brick Fight|<&a>Ready|<&a>[Click to Join]|<&b><&l><[num]> / <[config.max_players]>" <location[bf_sign]>
    - if <player.has_flag[bf.playing]>:
        - define team <player.flag[bf.team].keys.first>
        #remove bf flag before checking for end of game
        - flag <player> bf:!
        - teleport <location[bf_main_lobby_spawn]>
        - wait 2t
        - inventory set o:bf<player.uuid>
        - adjust <player> gamemode:creative if:<player.has_permission[dscript.brickfight.admin]>
        - adjust <player> gamemode:survival if:!<player.has_permission[dscript.brickfight.admin]>
        - adjust <player> can_fly:true if:<player.has_permission[essentials.fly]>
        - adjust <player> fly_speed:0.15 if:<player.has_permission[essentials.speed.fly]>
        - adjust <player> remove_effects
        - feed
        - heal
        - sidebar remove players:<player>
        - bossbar remove bf_bossbar players:<player>
        - if <server.online_players_flagged[bf.team.<[team]>].size> == 0:
            - run bf_end_task
    - if <player.has_flag[bf.spectator]>:
        - flag <player> bf:!
        - teleport <player> <location[bf_main_lobby_spawn]>
        - adjust <player> gamemode:creative if:<player.has_permission[dscript.brickfight.admin]>
        - adjust <player> gamemode:survival if:!<player.has_permission[dscript.brickfight.admin]>
        - sidebar remove players:<player>
        - bossbar remove bf_bossbar players:<player>

##########################
##          GUIs        ##
##########################

bf_team_gui:
  type: inventory
  debug: false
  inventory: chest
  title: <&5><&l>Choose your Team
  size: 9
  gui: true
  slots:
  - [] [] [bf_blue_chestplate] [] [] [] [bf_red_chestplate] [] []

bf_shop_gui:
  type: inventory
  debug: false
  inventory: chest
  title: <&8>Team Shop
  size: 9
  gui: true
  slots:
  - [<proc[bf_strong_arm_procedure]>] [<proc[bf_helmet_procedure]>] [<proc[bf_leggings_procedure]>] [bf_gapple] [<proc[bf_forge_procedure]>] [] [] [] []

##########################
##      PROCEDURES      ##
##########################

bf_strong_arm_procedure:
  type: procedure
  debug: false
  script:
  - define team <player.flag[bf.team].keys.first>
  - if !<server.has_flag[bf.<[team]>.strong_arm]>:
    - determine bf_strong_arm
  - if <server.has_flag[bf.<[team]>.strong_arm]>:
    - determine bf_strong_arm_complete

bf_helmet_procedure:
  type: procedure
  debug: false
  script:
  - define team <player.flag[bf.team].keys.first>
  - if !<server.has_flag[bf.<[team]>.leather_helm]> && !<server.has_flag[bf.<[team]>.neth_helm]>:
    - determine bf_leather_helmet
  - if <server.has_flag[bf.<[team]>.leather_helm]> && !<server.has_flag[bf.<[team]>.neth_helm]>:
    - determine bf_netherite_helmet
  - if <server.has_flag[bf.<[team]>.neth_helm]>:
    - determine bf_helmets_complete

bf_leggings_procedure:
  type: procedure
  debug: false
  script:
  - define team <player.flag[bf.team].keys.first>
  - if !<server.has_flag[bf.<[team]>.speed_leggings]>:
    - determine bf_speed_leggings
  - if <server.has_flag[bf.<[team]>.speed_leggings]>:
    - determine bf_leggings_complete

bf_forge_procedure:
  type: procedure
  debug: false
  script:
  - define team <player.flag[bf.team].keys.first>
  - if !<server.has_flag[bf.<[team]>.forge]>:
    - determine bf_forge
  - if <server.has_flag[bf.<[team]>.forge]>:
    - determine bf_forge_complete

##########################
##       COMMANDS       ##
##########################

bf_commands:
    type: command
    debug: false
    name: brickfight
    description: brickfight commands
    usage: /brickfight [arg] (arg2)
    aliases:
        - bf
    tab completions:
        1: leave|reset|kick|setup|show_arena|get_inventory|overwrite_schem
        2: <server.online_players.parse[name]>
    script:
    - define arg <context.args.get[1].if_null[null]>
    - define arg2 <server.match_player[<context.args.get[2]>].if_null[null]>
    - choose <[arg]>:
        - case null:
            - narrate "<&c>Syntax is /bf [arg] (arg2)"
            - stop
        - case leave:
            - if !<player.has_flag[bf.pregame]> && !<player.has_flag[bf.playing]> && !<player.has_flag[bf.spectator]>:
                - narrate "<&c>Not in Brick Fight!"
                - stop
            - inject bf_leave_task
        - case kick:
            - if <player.has_permission[dscript.brickfight.mod]>:
                - if <[arg2]> == null:
                    - narrate "<&c>Player not found!"
                    - stop
                - if !<[arg2].has_flag[bf]>:
                    - narrate "<&c>Player is not in Brick Fight."
                    - stop
                - adjust <queue> linked_player:<[arg2]>
                - inject bf_leave_task
            - else:
                - narrate "<&c>This is a Moderator command. Please contact the manager if you think you should have permissions."
        - case get_inventory:
            - if <player.has_permission[dscript.brickfight.admin]>:
                - clickable save:bf_get_inventory until:10s:
                    - define playeruuid <player[<[arg2]>].uuid>
                    - inventory set o:bf<[playeruuid]>
                - clickable save:bf_abort_inventory until:10s:
                    - narrate Aborted
                - narrate "Are you sure? This will delete your inventory and replace it with <[arg2]>'s inventory. <&a><element[YES].on_click[<entry[bf_get_inventory].command>]> <&f>/ <&c><element[NO].on_click[<entry[bf_abort_inventory].command>]>"
            - else:
                - narrate "<&c>This is an Admin-Only command."
        - case setup:
            - if <player.has_permission[dscript.brickfight.manager]>:
                - narrate "<&a>Brick Fight Setup Mode!"
                - flag <player> bf_setup
                - wait 10t
                - inventory open d:bf_setup_gui
            - else:
                - narrate "<&c>This is a manager-only command."
        - case show_arena:
          - if <player.has_permission[dscript.brickfight.admin]>:
            - run bf_show_arena_task
          - else:
            - narrate "<&c>This is an admin-only command."
        - case reset:
            - if <player.has_permission[dscript.brickfight.admin]>:
              - clickable save:bf_reset until:10s:
                  - if !<schematic.list.contains_single[bf_schematic]>:
                    - narrate "Loading Schematic..."
                    - ~schematic load name:bf_schematic
                  - narrate "Rebuilding Arena..."
                  - ~schematic paste name:bf_schematic <cuboid[bf_arena].center>
                  - narrate Done!
              - clickable save:bf_abort_inventory until:10s:
                  - narrate Aborted
              - narrate "This will reload the arena from the saved schematic. Are you sure? <&a><element[YES].on_click[<entry[bf_reset].command>]> <&f>/ <&c><element[NO].on_click[<entry[bf_reset].command>]>"
        #You can use this command to make adjustments to your arena after setup is complete.
        #Enter the command after your changes are complete and it will overwrite the bf_schematic.
        - case overwrite_schem:
            - if <player.has_permission[dscript.brickfight.manager]> && <cuboid[bf_arena].exists>:
                - narrate Overwriting....
                - ~schematic create name:bf_schematic <cuboid[bf_arena].center> area:<cuboid[bf_arena]> flags
                - narrate Saving....
                - ~schematic save name:bf_schematic
                - narrate Done!
            - if <player.has_permission[dscript.brickfight.manager]> && !<cuboid[bf_arena].exists>:
                - narrate "The arena does not exist."
                - narrate "Use <&6>/bf setup<&f> to create your arena"
            - if !<player.has_permission[dscript.brickfight.manager]>:
                - narrate "<&c>This is a manager-only command."

##########################
##       HANDLERS       ##
##########################

brickfight_handler:
    type: world
    debug: false
    data:
        #Uncomment interactables as required for your arena. The default selection is set for the bf_arena schematic provided.
        interactables:
        # ender_chest
        - beacon
        # lever
        # comparator
        # repeater
        # bell
        # enchanting_table
        # lectern
        - furnace
        - smoker
        - grindstone
        - loom
        - jukebox
        - smithing_table
        - cartography_table
        - stonecutter
        - blast_furnace
        # dispenser
        # hopper
        # dropper
        - crafting_table
        - barrel
        - note_block
        # respawn_anchor
        - decorated_pot
        - flower_pot
        - potted_flowering_azalea_bush
    subscripts:
        masonry_brick:
        - shoot snowball origin:<player> shooter:<player> speed:<element[1].mul[<[speed_multiplier]>]> save:brick_thrown
        - define brick <entry[brick_thrown].shot_entity>
        - adjust <[brick]> item:<item[brick].with[custom_model_data=100]>
        - flag <[brick]> bf.brick:masonry_brick
        - playsound <player.location> sound:ENTITY_WITCH_THROW pitch:1.15
        iron_brick:
        - shoot snowball origin:<player> shooter:<player> speed:<element[0.5].mul[<[speed_multiplier]>]> save:brick_thrown
        - define brick <entry[brick_thrown].shot_entity>
        - adjust <[brick]> item:<item[iron_ingot].with[custom_model_data=101]>
        - flag <[brick]> bf.brick:iron_brick
        - playsound <player.location> sound:ENTITY_WITCH_THROW pitch:0.8
        explosive_brick:
        - shoot snowball origin:<player> shooter:<player> speed:<element[0.8].mul[<[speed_multiplier]>]> save:brick_thrown
        - define brick <entry[brick_thrown].shot_entity>
        - adjust <[brick]> item:<item[nether_brick].with[custom_model_data=102]>
        - flag <[brick]> bf.brick:explosive_brick
        - playsound <player.location> sound:ENTITY_WITCH_THROW pitch:1
        point_calculator:
        - define blocks <[hit_loc].flood_fill[<[fill]>].types[<[hit_loc].material.name>]>
        - define points 1
        #random chance to break periphery blocks depending on brick type used
        - foreach <[blocks]> as:hit_block:
            - if <util.random_chance[<[chance]>]>:
                - playeffect at:<[hit_block].center> effect:BLOCK special_data:<[hit_block].material.name> quantity:8
                - modifyblock <[hit_block]> air
                - define points <[points].add[0.35]>
        #always break the hit block
        - modifyblock <[hit_loc]> air
        - playeffect at:<[hit_loc].center> effect:BLOCK special_data:<[hit_loc].material.name> quantity:8
        - define points <[points].round_up>
        - playsound <[hit_loc]> sound:block_glass_break pitch:0.8

    events:
        on player right clicks block with:*_brick in:bf_arena flagged:bf.playing server_flagged:bf.in_session:
        #prevent auto-clicker
        - ratelimit <player> 2t
        - if !<context.location.exists> || <context.location.material.name> !matches lever|*button|*door|*chest:
            - if <context.location.exists> && <context.location.material.name> in <script.data_key[data.interactables]>:
              - determine cancelled passively
            - define team <player.flag[bf.team].keys.first>
            - define speed_multiplier 1.5 if:<server.has_flag[bf.<[team]>.strong_arm]>
            - define speed_multiplier 1 if:!<server.has_flag[bf.<[team]>.strong_arm]>
            - inject <script.name>.subscripts.<player.item_in_hand.script.name>
            - take iteminhand quantity:1

        on entity_flagged:bf.brick hits in:bf_arena server_flagged:bf.in_session:
        - define hit_loc <context.hit_block> if:<context.hit_block.exists>
        - define hit_loc <context.hit_entity.eye_location> if:<context.hit_entity.exists>
        - define config <script[bf_config].data_key[]>
        - define team <context.shooter.flag[bf.team].keys.first>
        - define enemy_team red if:<[team].equals[blue]>
        - define enemy_team blue if:<[team].equals[red]>
        - choose <context.projectile.flag[bf.brick]>:
            - case masonry_brick:
                - playsound <[hit_loc]> sound:BLOCK_STONE_BREAK
                - define fill 1
                - define chance 30
            - case iron_brick:
                - playsound <[hit_loc]> sound:block_anvil_land pitch:0.75
                - define fill 1
                - define chance 60
            - case explosive_brick:
                #wait allows the damaged entity script to run before exploding the brick
                - wait 2t
                - explode <[hit_loc].above[1.3].center> power:2
                - define fill 2
                - define chance 90
        - if <context.hit_block.exists>:
            #earn points for breaking glass unreleated to team colors
            - if <context.hit_block> matches *glass*|redstone_lamp|*light|glowstone|*lantern && <context.hit_block> !matches blue_stained_glass*|red_stained_glass*:
                - inject <script.name>.subscripts.point_calculator
                - actionbar "<&color[<color[<[team]>]>]><[team].to_sentence_case> <&a>+<[points]>" targets:<server.online_players_flagged[bf.team.<[team]>]>
                - flag server bf.<[team]>.points:+:<[points]>
            #lose points for breaking your team's stained_glass
            - if <context.hit_block> matches <[team]>_stained_glass*:
                - inject <script.name>.subscripts.point_calculator
                - actionbar "<&color[<color[<[team]>]>]><[team].to_sentence_case><&c> -<[points]>" targets:<server.online_players_flagged[bf.team.<[team]>]>
                # prevent teams from having negative points
                - if <server.flag[bf.<[team]>.points].sub[<[points]>]> <= 0:
                  - define points <server.flag[bf.<[team]>.points]>
                - flag server bf.<[team]>.points:-:<[points]>
            #earn points for breaking enemy team's stained_glass and cause enemy team to lose points
            - if <context.hit_block> matches <[enemy_team]>_stained_glass*:
                - inject <script.name>.subscripts.point_calculator
                - actionbar "<&color[<color[<[team]>]>]><[team].to_sentence_case> <&a>+<[points]> <&f><&l>| <&color[<color[<[enemy_team]>]>]><[enemy_team].to_sentence_case> <&c>-<[points]>" targets:<server.online_players_flagged[bf.team]>
                - flag server bf.<[team]>.points:+:<[points]>
                # prevent teams from having negative points
                - if <server.flag[bf.<[enemy_team]>.points].sub[<[points]>]> <= 0:
                  - define points <server.flag[bf.<[enemy_team]>.points]>
                - flag server bf.<[enemy_team]>.points:-:<[points]>
            #collect drops and earn points from barrels and *pots
            - if <context.hit_block> matches *pot*|barrel:
                - determine cancelled passively
                - playsound <[hit_loc]> sound:block_decorated_pot_shatter pitch:0.5 volume:0.6
                - wait 1t
                #multiple brick types may drop from pots and barrels
                - if <util.random_chance[80]>:
                    - drop masonry_brick <[hit_loc]> quantity:<util.random.int[3].to[8]>
                - if <util.random_chance[20]>:
                    - drop iron_brick <[hit_loc]> quantity:<util.random.int[1].to[3]>
                - if <util.random_chance[20]>:
                    - drop explosive_brick <[hit_loc]> quantity:<util.random.int[1].to[3]>
                - modifyblock <[hit_loc]> air
                - define points <util.random.int[1].to[2]>
                - flag server bf.<[team]>.points:+:<[points]>
                - actionbar "<&color[<color[<[team]>]>]><[team].to_sentence_case> <&a>+<[points]>" targets:<server.online_players_flagged[bf.team.<[team]>]>
            - if <context.hit_block> matches *door:
                - if <util.random_chance[<[chance]>]>:
                    - modifyblock <[hit_loc]> air
                    - playsound <[hit_loc]> sound:block_wooden_door_close
                    - define points <util.random.int[2].to[3]>
                    - flag server bf.<[team]>.points:+:<[points]>
                    - actionbar "<&color[<color[<[team]>]>]><[team].to_sentence_case> <&a>+<[points]>" targets:<server.online_players_flagged[bf.team.<[team]>]>
        - run bf_sidebar_task

        on player damaged by entity_flagged:bf.brick in:bf_arena server_flagged:bf.in_session:
        - define team <context.damager.flag[bf.team].keys.first>
        - define enemy_team <context.entity.flag[bf.team].keys.first>
        - if <[team]> == <[enemy_team]> || <context.entity.has_flag[bf.invulnerable]>:
            - stop
        - define config <script[bf_config].data_key[]>
        # determine damage based on brick type
        # define likelyhood of concussion based on brick type
        - choose <context.projectile.flag[bf.brick]>:
            - case masonry_brick:
                - determine <[config.masonry_hit]> passively
                - define chance 5
            - case iron_brick:
                - determine <[config.iron_hit]> passively
                - define chance 30
            - case explosive_brick:
                - determine <[config.explosive_hit]> passively
                - define chance 10
        # adjust concussion chance based on helmet equipped
        - define chance <[chance].mul[<[config.leather_multiplier]>]> if:<context.entity.has_equipped[leather_helmet]>
        - define chance <[chance].mul[<[config.netherite_multiplier]>]> if:<context.entity.has_equipped[netherite_helmet]>
        # define damage taken
        - define determination <queue.determination.formatted>
        - define hurt_points <[determination].mul[<util.random.decimal[1.8].to[2.8]>].round_up>
        # prevent negative points
        - if <server.flag[bf.<[enemy_team]>.points].sub[<[hurt_points]>]> < 0:
            - define hurt_points <server.flag[bf.<[enemy_team]>.points]>
        - flag server bf.<[enemy_team]>.points:-:<[hurt_points]>
        - flag server bf.<[team]>.points:+:<[determination]>
        - actionbar "<&6>Direct hit! <&f><&l>| <&color[<color[<[team]>]>]><[team].to_sentence_case> <&a>+<[determination]> <&f><&l>| <&color[<color[<[enemy_team]>]>]><[enemy_team].to_sentence_case> <&c>-<[hurt_points]>" targets:<context.entity>|<context.damager>
        # give player concussion
        - if <util.random_chance[<[chance]>]> && !<context.entity.has_flag[bf.concussion]>:
            - cast darkness duration:4s <context.entity> no_icon
            - cast confusion amplifier:6 duration:8s <context.entity> no_icon
            - cast slow amplifier:1 duration:10s <context.entity> no_icon
            - flag <context.entity> bf.concussion expire:10s
            # double points for team causing concussion
            - flag server bf.<[team]>.points:+:<[determination]>
            # lose double points for receiving concussion
            # prevent negative points for team receiving concussion
            - if <server.flag[bf.<[enemy_team]>.points].sub[<[hurt_points]>]> < 0:
              - define hurt_points <server.flag[bf.<[enemy_team]>.points]>
            - flag server bf.<[enemy_team]>.points:-:<[hurt_points]>
            - actionbar "<&6>Concussion! <&f><&l>| <&color[<color[<[team]>]>]><[team].to_sentence_case> <&a>+<[determination].mul[2]> <&f><&l>| <&color[<color[<[enemy_team]>]>]><[enemy_team].to_sentence_case> <&c>-<[hurt_points].mul[2]>" targets:<context.entity>|<context.damager>
            - playeffect effect:firework at:<context.entity.location.above[1.8]> offset:1.5,0.6,1.5 quantity:180 visibility:30
        - if <[determination]> >= <context.entity.health>:
            - actionbar "<&6>Kill! <&f><&l>| <&color[<color[<[team]>]>]><[team].to_sentence_case> <&a>+<[determination].mul[2]> <&f><&l>| <&color[<color[<[enemy_team]>]>]><[enemy_team].to_sentence_case> <&c>-<[hurt_points].mul[2]>" targets:<context.entity>|<context.damager>
            # receive triple points for kill
            - flag server bf.<[team]>.points:+:<[determination].mul[2]>
            # lose double points for team killed
            # prevent negative points for team killed
            - if <server.flag[bf.<[enemy_team]>.points].sub[<[hurt_points]>]> < 0:
              - define hurt_points <server.flag[bf.<[enemy_team]>.points]>
            - flag server bf.<[enemy_team]>.points:-:<[hurt_points]>
            - if <context.entity.has_flag[bf.concussion]>:
              - flag <context.entity> bf.concussion:!
        - run bf_sidebar_task
        # Concussion stumbling effect
        - while <context.entity.has_flag[bf.concussion]>:
                #Push is preferred, however it gives 4 seconds of invulnerability for an unknown reason. Help post submitted to denizen on 17 Sep 24.
                #Using adjust velocity with repeat as a work around.
                # push <context.entity> origin:<context.entity.location> destination:<context.entity.location.add[<util.random.int[-5].to[5]>,0,<util.random.int[-5].to[5]>]> speed:0.2 duration:<util.random.int[15].to[25]>t no_rotate
                - define push <util.random.int[-2].to[2]>
                - define pushticks <util.random.int[15].to[50]>
                - repeat <[pushticks]>:
                  - adjust <context.entity> velocity:<context.entity.location.with_pitch[0].forward[<[push]>].left[<[push]>].sub[<context.entity.location.with_pitch[0]>].normalize.mul[0.2]>
                  - wait 1t
                - wait <[pushticks].mul[1.6].round_up>t

        on player picks up *_brick in:bf_arena flagged:bf server_flagged:bf.in_session:
        #dupe bricks when players both pick up at the same time. only works on items spawned at the forge.
        - define item <context.item>
        - define quantity <[item].quantity>
        - if <context.location.distance[bf_forge_blue].horizontal> <= 0.001 || <context.location.distance[bf_forge_red].horizontal> <= 0.001:
            - foreach <player.location.find_players_within[3]> as:splitter:
                - if <[splitter].name> matches <player.name> || <[splitter].gamemode.advanced_matches[spectator]>:
                    - foreach next
                - give <[item]> quantity:<[quantity]> player:<[splitter]>
                - playsound <[splitter].location> sound:entity_item_pickup

        #don't let player pick up non-brick items
        on player picks up !*_brick in:bf_arena flagged:bf server_flagged:bf.in_session:
        - determine cancelled

        #prevent broken pots from dropping vanilla bricks
        #allow players to get bricks from breaking pots and barrels with their bare hands
        on player breaks *pot||barrel in:bf_arena flagged:bf.playing server_flagged:bf.in_session:
        - determine <script[bf_config].data_key[bricks].random[2]>

        #protect the arena when the game isn't running
        on player breaks block in:bf_arena permission:!dscript.brickfight.admin server_flagged:!bf.in_session:
        - determine cancelled
    
        on player places block in:bf_arena permission:!dscript.brickfight.admin server_flagged:!bf.in_session:
        - determine cancelled

        #don't let the player drop anything other than bricks
        on player drops !*_brick in:bf_arena server_flagged:bf.in_session:
        - determine cancelled

        on player dies flagged:bf.playing in:bf_arena server_flagged:bf.in_session:
        - determine cancelled passively
        #flag the location so we can remove dropped items after the game
        - flag <context.entity.location> bf.death
        - define team <player.flag[bf.team].keys.first>
        - flag server bf.<[team]>.lives:--
        - feed
        - heal
        - playeffect effect:firework at:<context.entity.location.above> offset:0.5,0.5,0.5 quantity:80 visibility:40
        - cast darkness duration:2s
        - playsound <context.entity.location> sound:entity_cow_death pitch:2
        - wait 2t
        # drop player bricks at death location
        - foreach <script[bf_config].parsed_key[bricks]> as:brick:
            - if <context.entity.inventory.contains_item[<[brick]>]>:
                - define count <context.entity.inventory.quantity_item[<[brick]>]>
                - take item:<[brick]> quantity:<[count]>
                - drop <item[<[brick]>]> <context.entity.location.above[1]> quantity:<[count]> speed:0.1 delay:4t
        - teleport <location[bf_<[team]>_spawn].above>
        - wait 1t
        - playsound <context.entity.location> sound:entity_enderman_teleport
        # limit spawn killing
        - cast glowing duration:4s
        - flag <player> bf.invulnerable expire:4s
        - run bf_sidebar_task
        - if <server.flag[bf.<[team]>.lives]> <= 0:
          - wait 10t
          - run bf_end_task

brickfight_ancillaries:
    type: world
    debug: false
    events:
        on player right clicks *_wall_sign in:bf_sign_board:
        - determine cancelled passively
        #prevent simultaneous clicking
        - ratelimit player 2t
        - choose <context.location.note_name>:
          - case bf_sign:
            - if <server.has_flag[bf.in_session]>:
                - narrate "<&c>A game is already in session!"
                - stop
            - define config <script[bf_config].data_key[]>
            - define max_players <[config.max_players]>
            - define min_players <[config.min_players]>
            - flag <player> bf.pregame
            - define num <server.online_players_flagged[bf.pregame].size>
            - if <[num]> > <[max_players]>:
                - flag <player> bf.pregame:!
                - define num <server.online_players_flagged[bf.pregame]>
                - narrate "<&c>The game is full!"
                - stop
            - if <[num]> <= <[max_players]>:
                - teleport <player> <location[bf_pregame_lobby_spawn]>
                - playsound <player> sound:entity_enderman_teleport
                # save the player inventory
                - note <player.inventory> as:bf<player.uuid>
                - wait 1t
                # set the team selector inventory
                - inventory clear
                - inventory set o:bf_team_selector slot:1
                - inventory set o:bf_leave_selector slot:9
            - sign type:automatic material:dark_oak_sign "<&e><&l>Brick Fight|<&a>Ready|<&a>[Click to Join]|<&b><&l><[num]> / <[max_players]>" <location[bf_sign]>
          - case bf_admin_sign:
            - if <player.has_permission[dscript.brickfight.admin]>:
              - flag <player> bf.admin expire:5s
              - teleport <player> <location[bf_admin_spawn]>
              - playsound <player> sound:entity_enderman_teleport
              - flag <player> bf:!
            - else:
              - narrate "<&c>Admins only."
            - stop
          - case bf_spec_sign:
            - if <server.has_flag[bf.in_session]>:
              - flag <player> bf.spectator
              - teleport <player> <location[bf_admin_spawn]>
              - adjust <player> gamemode:spectator
              - playsound <player> sound:entity_enderman_teleport
            - else:
              - narrate "<&c>Brick Fight is not in session!"
            - stop
        # start the countdown timer
        - if <[num]> == <[min_players]>:
            - wait 2s
            - define countdown 20
            - define bf_pregamers <server.online_players_flagged[bf.pregame]>
            - repeat 3:
                - actionbar "<&f>Starting in <&e><[countdown]><&f> Seconds!" targets:<[bf_pregamers]>
                - inject bf_countdown_task
                - wait 4s
                - define countdown <[countdown].sub[5]>
            - define left <&c><&gt><&gt><&8>----<&c><&gt>
            - define right <&c><&lt><&8>----<&c><&lt><&lt>
            - actionbar "<[left]>       <&e>6       <[right]>" targets:<[bf_pregamers]>
            - inject bf_countdown_task
            - actionbar "<[left]>      <&e>5      <[right]>" targets:<[bf_pregamers]>
            - inject bf_countdown_task
            - actionbar "<[left]>     <&e>4     <[right]>" targets:<[bf_pregamers]>
            - inject bf_countdown_task
            - actionbar "<[left]>    <&e>3    <[right]>" targets:<[bf_pregamers]>
            - inject bf_countdown_task
            - actionbar "<[left]>   <&e>2   <[right]>" targets:<[bf_pregamers]>
            - inject bf_countdown_task
            - actionbar "<[left]>  <&e>1  <[right]>" targets:<[bf_pregamers]>
            - inject bf_countdown_task
            - if <[num]> < <[min_players]>:
                - narrate "<&c>There aren't enough players!"
                - foreach <[bf_pregamers]> as:leaving:
                    - adjust <queue> linked_player:<[leaving]>
                    - inject bf_leave_task
                    - wait 1t
                - stop
            - actionbar "<[left]> <&e>0 <[right]>" targets:<[bf_pregamers]>
            - sign type:automatic material:dark_oak_sign "<&e><&l>Brick Fight||<&c>Running!|" <location[bf_sign]>
            - playsound <[bf_pregamers]> sound:block_note_block_harp pitch:2.5
            - wait 2t
            - cast blindness duration:2s <[bf_pregamers]> no_icon
            - playsound <[bf_pregamers]> sound:entity_enderman_teleport
            - heal <[bf_pregamers]>
            - adjust <[bf_pregamers]> remove_effects
            - foreach <[bf_pregamers]> as:bf_player:
                # if player failed to choose a team, choose one for him
                - if !<[bf_player].has_flag[bf.team]>:
                    - define blue <server.online_players_flagged[bf.team.blue].size>
                    - define red <server.online_players_flagged[bf.team.red].size>
                    - if <[blue]> > <[red]>:
                        - flag <[bf_player]> bf.team.red
                    - if <[red]> >= <[blue]>:
                        - flag <[bf_player]> bf.team.blue
                # disable fly and set gamemode survival
                - if <[bf_player].has_permission[essentials.fly]>:
                    - adjust <[bf_player]> can_fly:false
                    - adjust <[bf_player]> flying:false
                - if !<[bf_player].gamemode.advanced_matches[survival]>:
                    - adjust <[bf_player]> walk_speed:0.2
                    - adjust <[bf_player]> gamemode:survival
                - wait 1t
            - define blue <server.online_players_flagged[bf.team.blue]>
            - define red <server.online_players_flagged[bf.team.red]>
            # if teams are out of balance, force a random player to switch teams
            - while <[blue].size> == 0 || <[blue].size> <= <[red].size.sub[2]>:
                - define crossover <[red].random>
                - flag <[crossover]> bf.team.red:!
                - flag <[crossover]> bf.team.blue
                - define blue <server.online_players_flagged[bf.team.blue]>
                - define red <server.online_players_flagged[bf.team.red]>
                - if <[loop_index]> >= <[max_players].div[2]>:
                    - while stop
            - while <[red].size> == 0 || <[red].size> <= <[blue].size.sub[2]>:
                - define crossover <[blue].random>
                - flag <[crossover]> bf.team.blue:!
                - flag <[crossover]> bf.team.red
                - define blue <server.online_players_flagged[bf.team.blue]>
                - define red <server.online_players_flagged[bf.team.red]>
                - if <[loop_index]> >= <[max_players].div[2]>:
                    - while stop
            # flag the server
            - define start_lives <[bf_pregamers].size.add[<[config.start_lives_addend]>]>
            - flag server bf.in_session
            - flag server bf.timer:<[config.timer]>
            - flag server bf.blue.points:<[config.start_points]>
            - flag server bf.blue.lives:<[start_lives]>
            - flag server bf.red.points:<[config.start_points]>
            - flag server bf.red.lives:<[start_lives]>
            # tp players to their bases
            - playsound <[bf_pregamers]> sound:entity_generic_explode
            - flag <[bf_pregamers]> bf.pregame:!
            - flag <[bf_pregamers]> bf.playing
            - flag <[bf_pregamers]> bf.entering expire:10s
            - foreach <[bf_pregamers]> as:tp:
                - feed <[tp]>
                - teleport <[tp]> <location[bf_<[tp].flag[bf.team].keys.first>_spawn].above>
                - wait 1t
            - announce <&6>********************************************** to_flagged:bf
            - announce "           <&6><&n>BRICK FIGHT<&r>                  " to_flagged:bf
            - announce <empty> to_flagged:bf
            - announce "Collect bricks. Break stuff." to_flagged:bf
            - announce "Buy upgrades. Hit people." to_flagged:bf
            - announce "Protect your team's stained glass." to_flagged:bf
            - announce "First team to 0 lives loses!" to_flagged:bf
            - announce <&6>********************************************** to_flagged:bf

        on player clicks block with:bf_team_selector||*_chestplate in:bf_pregame_lobby flagged:bf.pregame:
        - ratelimit <player> 2t
        - determine cancelled passively
        - inventory open d:bf_team_gui

        after player clicks block with:bf_leave_selector in:bf_pregame_lobby flagged:bf.pregame:
        - ratelimit <player> 4t
        - inventory close
        - flag <player> bf:!
        - inventory set o:bf<player.uuid>
        - teleport <location[bf_main_lobby_spawn]>
        - playsound <player> sound:entity_enderman_teleport
        - define max_players <script[bf_config].data_key[max_players]>
        - define num <server.online_players_flagged[bf.pregame].size>
        - sign type:automatic "<&e><&l>Brick Fight|<&a>Ready|<&a>[Click to Join]|<&b><&l><[num]> / <[max_players]>" <location[bf_sign]>

        after player clicks in bf_team_gui in_area:bf_pregame_lobby flagged:bf.pregame:
        - ratelimit <player> 5t
        - if <context.item> matches *chestplate:
          - define team <context.item.flag[team]>
          - inventory set o:bf_<[team]>_chestplate slot:1
          - inventory set o:bf_<[team]>_chestplate slot:39
          - inventory set o:bf_leggings slot:38
          - inventory set o:bf_<[team]>_boots slot:37
          - flag <player> bf.team:! if:<player.has_flag[bf.team]>
          - playsound <player> sound:entity_horse_armor
          - flag <player> bf.team.<[team]>
          - inventory close

        after player right clicks npc_flagged:bf.shop in:bf_arena flagged:bf.playing server_flagged:bf.in_session:
        - inventory open d:bf_shop_gui

        after player clicks in bf_shop_gui in_area:bf_arena flagged:bf.playing server_flagged:bf.in_session:
        #prevent simultaneous clicking
        - ratelimit player 2t
        - if <context.clicked_inventory.advanced_matches[player]> || <context.item.advanced_matches[air]>:
          - determine cancelled
        - define color <player.flag[bf.team].keys.first>
        - define cost <context.item.flag[cost]>
        - if <server.flag[bf.<[color]>.points]> < <[cost]>:
          - narrate "<&c>Insufficient Funds"
          - stop
        - define item <context.item.flag[bf]>
        - define team <server.online_players_flagged[bf.team.<[color]>]>
        #Upgrades apply to the entire team
        - choose <[item]>:
          - case bf_speed_leggings:
            - foreach <[team]> as:member:
              - inventory set o:<[item]> d:<[member].inventory> slot:38
            - flag server bf.<[color]>.speed_leggings
            - playsound <[team]> sound:entity_horse_armor
            - actionbar "<&a>Speed Pants Applied!" targets:<[team]>
            - narrate "<&a>Speed Pants Applied!" targets:<[team]>
            - cast speed duration:<server.flag[bf.timer].mul[1.1]> <[team]> hide_particles
          - case bf_leather_helmet:
            - foreach <[team]> as:member:
              - inventory set o:<[item]> d:<[member].inventory> slot:40
            - flag server bf.<[color]>.leather_helm
            - playsound <[team]> sound:entity_horse_armor
            - actionbar "<&a>Hard Hat Equipped!" targets:<[team]>
            - narrate "<&a>Hard Hat Equipped!" targets:<[team]>
          - case bf_netherite_helmet:
            - foreach <[team]> as:member:
              - inventory set o:<[item]> d:<[member].inventory> slot:40
            - flag server bf.<[color]>.neth_helm
            - playsound <[team]> sound:entity_horse_armor
            - actionbar "<&a>Kevlar Equipped!" targets:<[team]>
            - narrate "<&a>Kevlar Equipped!" targets:<[team]>
          - case bf_strong_arm:
            - flag server bf.<[color]>.strong_arm
            - playsound <[team]> sound:entity_blaze_shoot
            - actionbar "<&a>Strong Arm!" targets:<[team]>
            - narrate "<&a>Strong Arm!" targets:<[team]>
          - case bf_forge:
            - flag server bf.<[color]>.forge
            - playsound <[team]> sound:block_anvil_use
            - actionbar "<&a>Forge Upgraded!" targets:<[team]>
            - narrate "<&a>Forge Upgraded!" targets:<[team]>
          - case gapple:
            - playsound <player> sound:entity_item_frame_add_item
            - give golden_apple
        - flag server bf.<[color]>.points:-:<[cost]>
        - inventory open d:bf_shop_gui
        - run bf_sidebar_task

        on player exits bf_pregame_lobby flagged:bf.pregame:
        - determine cancelled passively
        - ratelimit <player> 1s
        - narrate "Use <&e>/bf leave<&f> to exit."

        after player enters bf_arena flagged:bf.entering server_flagged:bf.in_session:
        - inventory clear
        - define team <player.flag[bf.team].keys.first>
        - inventory set o:bf_<[team]>_chestplate slot:39
        - inventory set o:bf_leggings slot:38
        - inventory set o:bf_<[team]>_boots slot:37
        - run bf_sidebar_task
        - flag <player> bf.entering:!

        on player clicks in inventory in_area:bf_pregame_lobby flagged:bf.pregame:
        - determine cancelled

        on player drags in inventory in_area:bf_pregame_lobby flagged:bf.pregame:
        - determine cancelled

        on player drops bf_team_selector||bf_leave_selector||*chestplate||*boots in:bf_pregame_lobby flagged:bf.pregame:
        - determine cancelled

        on delta time secondly every:1 server_flagged:bf.in_session:
        - ~run bf_bossbar_task
        - ~run bf_loot_task

        on player unequips armor flagged:bf permission:!dscript.brickfight.admin:
        - determine cancelled

        on player quits flagged:bf:
        - if <player.has_flag[bf.pregame]>:
          - inventory set o:bf<player.uuid>
          - flag <player> bf:!
          - teleport <location[bf_main_lobby_spawn]>
        - if <player.has_flag[bf.spectator]>:
          - flag <player> bf:!
          - teleport <player> <location[bf_main_lobby_spawn]>
          - adjust <player> gamemode:creative if:<player.has_permission[dscript.brickfight.admin]>
          - adjust <player> gamemode:survival if:!<player.has_permission[dscript.brickfight.admin]>
          - sidebar remove players:<player>
          - bossbar remove bf_bossbar players:<player>
        - if <player.has_flag[bf.playing]>:
          - inventory set o:bf<player.uuid>
          - define team <player.flag[bf.team].keys.first>
          - flag <player> bf:!
          - teleport <location[bf_main_lobby_spawn]>
          - sidebar remove players:<player>
          - bossbar remove bf_bossbar players:<player>
          - adjust <player> gamemode:creative if:<player.has_permission[dscript.brickfight.admin]>
          - adjust <player> gamemode:survival if:!<player.has_permission[dscript.brickfight.admin]>
          - adjust <player> can_fly:true if:<player.has_permission[essentials.fly]>
          - adjust <player> fly_speed:0.15 if:<player.has_permission[essentials.speed.fly]>
          - if <server.online_players_flagged[bf.team.<[team]>].size> == 0:
            - run bf_end_task

        on player enters bf_arena flagged:!bf|!bf_setup:
        - determine cancelled passively
        - ratelimit <player> 1s
        - narrate "<&c>You do not have permission to enter this arena!"

        on player exits bf_arena server_flagged:bf.in_session flagged:bf:
        # don't trust the player. no one leaves unless they quit or the game ends
        - determine cancelled passively
        - teleport <player> <location[bf_admin_spawn]>
        - ratelimit <player> 1s
        - narrate "Use <&e>/bf leave<&f> to exit!"

        after player exits bf_arena server_flagged:bf.in_session flagged:bf:
        #really, really, don't trust the player. cuz they will figure out a way to leave....
        - inject bf_leave_task

        after player enters bf_main_lobby flagged:bf_postgame:
        #return player saved inventories
        - inventory set origin:bf<player.uuid>
        - wait 1t
        - flag <player> bf_postgame:!

        on player changes food level in:bf_arena flagged:bf server_flagged:bf.in_session:
        # prevent player from getting hungry
        - ratelimit <player> 1s
        - feed
        - determine cancelled

        on command in:bf_arena server_flagged:bf.in_session flagged:bf permission:!dscript.brickfight.admin:
        # don't trust the player. only admins can use non-brickfight commands while in brick fight
        - if !<context.command.advanced_matches[bf]> && !<context.command.advanced_matches[brickfight]>:
            - determine cancelled passively
            - narrate "<&c>You may only use <&e>/bf <&c>commands while in Brick Fight"

        on mob spawns in:bf_arena server_flagged:bf.in_session:
        - determine cancelled

        on player heals because satiated in:bf_arena flagged:bf.playing server_flagged:bf.in_session:
        # prevent player natural regen
        - determine cancelled

##END OF MINIGAME SCRIPT

#####################################################
#                                                   #
####               BRICK FIGHT SETUP             ####
#                                                   #
#####################################################

##########################
##         DATA         ##
##########################

bf_setup_config:
  type: data
  debug: false
  player_flags:
    bf_setup:
      - arena_boundary_1
      - arena_boundary_2
      - blue_forge
      - blue_chest
      - blue_shop
      - red_forge
      - red_chest
      - red_shop
      - admin_spawn
      - main_lobby
      - pregame_lobby
      - pregame_lobby_boundary_1
      - pregame_lobby_boundary_2
      - signboard
      - waiting
      - complete
    bf_setup_procedure_flags:
      - complete
      - arena
      - blue_base
      - red_base
      - admin_spawn
      - lobbies
      - signboard
  location_flags:
    bf:
      forge:
        - blue
        - red
  noted_locations:
    - bf_arena_corner_1
    - bf_arena_corner_2
    - bf_arena
    - bf_forge_blue
    - bf_blue_spawn
    - bf_forge_red
    - bf_red_spawn
    - bf_admin_spawn
    - bf_blue_chest
    - bf_red_chest
    - bf_main_lobby
    - bf_main_lobby_spawn
    - bf_pregame_lobby_corner_1
    - bf_pregame_lobby_corner_2
    - bf_pregame_lobby
    - bf_pregame_lobby_spawn
    - bf_sign_board
    - bf_sign
    - bf_spec_sign
    - bf_admin_sign

##########################
##       HANDLER        ##
##########################

bf_setup_handler:
  type: world
  debug: false
  events:
    on player left clicks block flagged:bf_setup with:bf_setup_wand type:!air permission:dscript.brickfight.manager:
    - ratelimit <player> 2s
    - determine cancelled passively
    - clickable save:bf_setup_gui until:10s:
      - inventory open d:bf_setup_gui
    - choose <player.flag[bf_setup]>:
        - case arena_boundary_1:
            - note <context.location.center> as:bf_arena_corner_1
            - showfake <context.location> glowstone
            - flag <player> bf_setup:arena_boundary_2
            - actionbar "<&a>Corner 1 Set!"
            - playsound <player> sound:block_anvil_land pitch:2
            - wait 1.5s
            - actionbar "Left click <&e>Corner 2"
            - narrate "Left click <&e>Corner 2"
        - case arena_boundary_2:
            - note <context.location.center> as:bf_arena_corner_2
            - actionbar "<&a>Corner 2 Set"
            - playsound <player> sound:block_anvil_use
            - note <location[bf_arena_corner_1].to_cuboid[<location[bf_arena_corner_2]>]> as:bf_arena
            - showfake glowstone <cuboid[bf_arena].outline>
            - flag <player> bf_setup_procedure_flags.arena
            - note remove as:bf_arena_corner_1
            - note remove as:bf_arena_corner_2
            - flag <player> bf_setup:waiting
            - wait 1.5s
            - actionbar "<&a>Boundaries Complete!"
            - playsound <player> sound:entity_player_levelup
            - inject bf_setup_job_complete_task
            - narrate "Click <&6><element[/bf setup].on_click[<entry[bf_setup_gui].command>]> <&f>to continue with setup"
        - case blue_forge red_forge:
            - define color blue if:<player.flag[bf_setup].contains_text[blue]>
            - define color red if:<player.flag[bf_setup].contains_text[red]>
            - define formatted_team <&color[<color[<[color]>]>]><[color].to_sentence_case>
            - note <context.location.above.center> as:bf_forge_<[color]>
            #team spawn is located on team forge
            - note <context.location.center> as:bf_<[color]>_spawn
            - flag <context.location.above> bf.forge.<[color]>
            - showfake <context.location> iron_block
            - actionbar "<[formatted_team]> Forge <&a>Complete!"
            - playsound <player> sound:block_anvil_land pitch:2
            - flag <player> bf_setup:<[color]>_chest
            - wait 1.5s
            - actionbar "Left click to set <[formatted_team]> Chest"
            - narrate "Left click to set <[formatted_team]> Chest"
        - case blue_chest red_chest:
            - define color blue if:<player.flag[bf_setup].contains_text[blue]>
            - define color red if:<player.flag[bf_setup].contains_text[red]>
            - define formatted_team <&color[<color[<[color]>]>]><[color].to_sentence_case>
            - modifyblock <context.location.above> chest
            - adjust <context.location.above> block_facing:<proc[bf_setup_chest_facing_proc]>
            - note <context.location.above> as:bf_<[color]>_chest
            - flag <player> bf_setup:<[color]>_shop
            - actionbar "<[formatted_team]> Chest<&a> Complete!"
            - playsound <player> sound:block_chest_close
            - wait 1.5s
            - actionbar "<&f>Set <[formatted_team]> Shop"
            - narrate "Left Click to Set <[formatted_team]> Shop"
        - case blue_shop red_shop:
            - define color blue if:<player.flag[bf_setup].contains_text[blue]>
            - define color red if:<player.flag[bf_setup].contains_text[red]>
            - define formatted_team <&color[<color[<[color]>]>]><[color].to_sentence_case>
            - create player "<[formatted_team]> Shop" <context.location.above.center> save:bf_<[color]>_shop
            - adjust <entry[bf_<[color]>_shop].created_npc> lookclose:true
            - flag <entry[bf_<[color]>_shop].created_npc> bf.shop.<[color]>
            - playsound <player> sound:entity_villager_trade
            - actionbar "<[formatted_team]> Shop <&a>Complete!"
            - flag <player> bf_setup_procedure_flags.<[color]>_base
            - flag <player> bf_setup:waiting
            - wait 1.5s
            - playsound <player> sound:entity_player_levelup
            - narrate "<[formatted_team]> Base <&a>Complete"
            - actionbar "<[formatted_team]> Base <&a>Complete"
            - wait 1.5s
            - inject bf_setup_job_complete_task
            - narrate "Click <&6><element[/bf setup].on_click[<entry[bf_setup_gui].command>]> <&f>to continue with setup"
        - case admin_spawn:
          - note <context.location.above> as:bf_admin_spawn
          - showfake <context.location> yellow_concrete
          - flag <player> bf_setup_procedure_flags.admin_spawn
          - actionbar "<&6>Admin Spawn<&a> Complete!"
          - playsound <player> sound:block_anvil_land pitch:2
          - flag <player> bf_setup:waiting
          - playsound <player> sound:entity_player_levelup
          - wait 1.5s
          - inject bf_setup_job_complete_task
          - narrate "Click <&6><element[/bf setup].on_click[<entry[bf_setup_gui].command>]> <&f>to continue with setup"
        - case main_lobby:
          - note <context.location.above> as:bf_main_lobby_spawn
          - note <context.location.add[2,5,2].to_cuboid[<context.location.add[-2,-2,-2]>]> as:bf_main_lobby
          - playsound <player> sound:block_anvil_land
          - showfake <context.location> diamond_block d:7s
          - showfake <cuboid[bf_main_lobby].outline> diamond_block d:7s
          - playsound <player> sound:block_anvil_use
          - actionbar "Main Lobby Cuboid <&a>Auto-Generated!"
          - flag <player> bf_setup:pregame_lobby
          - wait 1.5s
          - actionbar "Main Lobby Setup <&a>Complete!"
          - playsound <player> sound:entity_player_levelup
          - wait 1.5s
          - actionbar "Set <&e>Pregame Spawnpoint"
          - narrate "Left Click to Set <&e>Pregame Waiting Area Spawnpoint"
        - case pregame_lobby:
          - if <context.location.is_in[bf_main_lobby]>:
              - narrate "The waiting area must not be in the main lobby!"
              - stop
          - note <context.location.above> as:bf_pregame_lobby_spawn
          - showfake <context.location> cut_copper
          - actionbar "Pregame Waiting Area Spawn <&a>Complete!"
          - playsound <player> sound:block_anvil_land
          - narrate "Pregame Waiting Area Spawn <&a>Complete!"
          - flag <player> bf_setup:pregame_boundary_1
          - wait 1.5s
          - actionbar "Set <&e>Pregame Waiting Area <&f>Corner 1"
          - narrate "Set <&e>Pregame Waiting Area <&f>Corner 1"
        - case pregame_boundary_1:
          - if <context.location.is_in[bf_main_lobby]>:
              - narrate "The waiting area must not be in the main lobby!"
              - stop
          - note <context.location> as:bf_setup_pregame_lobby_corner_1
          - showfake <context.location> copper_block
          - flag <player> bf_setup:pregame_boundary_2
          - actionbar "Corner 1 <&a>Complete!"
          - playsound <player> sound:block_anvil_land
          - narrate "Pregame Waiting Area Corner 1 <&a>Complete!"
          - wait 1.5s
          - actionbar "Set <&e>Pregame Waiting Area <&f>Corner 2"
          - narrate "Right Click to Set <&e>Pregame Waiting Area <&f>Corner 2"
        - case pregame_boundary_2:
          - if <context.location.is_in[bf_main_lobby]>:
              - narrate "The waiting area must <&l>not <&f>be in the main lobby!"
              - stop
          - note <context.location> as:bf_setup_pregame_lobby_corner_2
          - showfake <context.location> copper_block
          - actionbar "<&a>Corner 2 Set"
          - playsound <player> sound:block_anvil_use
          - note <location[bf_setup_pregame_lobby_corner_1].to_cuboid[<location[bf_setup_pregame_lobby_corner_2]>]> as:bf_pregame_lobby
          - flag <player> bf_setup_procedure_flags.lobbies
          - flag <player> bf_setup:waiting
          - note remove as:bf_setup_pregame_lobby_corner_1
          - note remove as:bf_setup_pregame_lobby_corner_2
          - showfake <cuboid[bf_pregame_lobby].outline> copper_block
          - wait 1.5s
          - actionbar "<&e>Pregame Waiting Area<&a> Complete!"
          - playsound <player> sound:entity_player_levelup
          - wait 1s
          - inject bf_setup_job_complete_task
          - narrate "Click <&6><element[/bf setup].on_click[<entry[bf_setup_gui].command>]> <&f>to continue with setup"
        - case signboard:
          - if <context.location.is_in[bf_main_lobby]> || <context.location.is_in[bf_pregame_lobby]>:
              - narrate " "
              - narrate "The signboard must not be inside the lobby boundaries!"
              - stop
          - define direction <player.location.yaw.simple>
          - choose <[direction]>:
              - case north:
                - define left_sign <context.relative.right>
                - define right_sign <context.relative.left>
              - case south:
                - define left_sign <context.relative.left>
                - define right_sign <context.relative.right>
              - case west:
                - define left_sign <context.relative.forward>
                - define right_sign <context.relative.backward>
              - case east:
                - define left_sign <context.relative.backward>
                - define right_sign <context.relative.forward>
          - note <context.relative> as:bf_sign
          - note <[right_sign]> as:bf_spec_sign
          - note <[left_sign]> as:bf_admin_sign
          - note <context.location.add[-1,-1,-1].to_cuboid[<context.location.add[1,1,1]>]> as:bf_sign_board
          - sign type:wall_sign material:dark_oak_wall_sign "<&e><&l>Brick Fight|<&a>Ready|<&a>[Click to Join]|<&b>0" <context.relative>
          - sign type:wall_sign material:crimson_wall_sign "<&e><&l>Brick Fight||<&6>Admin Entry" <[left_sign]>
          - sign type:wall_sign material:spruce_wall_sign "<&e><&l>Brick Fight||<&3>[Click to Spec]" <[right_sign]>
          - playsound <player> sound:block_hanging_sign_place
          - flag <player> bf_setup:waiting
          - flag <player> bf_setup_procedure_flags.signboard
          - wait 0.5s
          - actionbar "<&f>Main Lobby Signboard<&a> Complete!"
          - playsound <player> sound:entity_player_levelup
          - if !<schematic.list.contains_single[bf_schematic]>:
              - narrate "Creating Schematic...."
              - ~schematic create name:bf_schematic <cuboid[bf_arena].center> area:<cuboid[bf_arena]> flags entities
              - narrate "Saving Schematic to your Denizen Schematics Folder...."
              - ~schematic save name:bf_schematic
          - narrate Done!
          - wait 1.5s
          - inject bf_setup_job_complete_task
          - narrate "Click <&6><element[/bf setup].on_click[<entry[bf_setup_gui].command>]> <&f>to continue with setup"
        - case waiting:
          - narrate "Choose your next setup action."
          - wait 0.5s
          - inventory open d:bf_setup_gui
        - case complete:
          - narrate "You are complete with setup."
          - narrate "Shift right-click with the setup wand to reopen the GUI, then select redo item if you need to change something."

    on player right clicks block with:bf_setup_wand permission:dscript.brickfight.manager:
    - ratelimit <player> 1t
    - if <player.is_sneaking>:
      - if !<player.has_flag[bf_setup_procedure_flags]>:
        - flag <player> bf_setup_procedure_flags
      - flag <player> bf_setup:waiting
      - inventory open d:bf_setup_gui

    after player left clicks in bf_setup_gui flagged:bf_setup permission:dscript.brickfight.manager:
    - define item <context.item.script.name.if_null[air]>
    - inventory close
    - choose <[item]>:
      - case bf_setup_wand:
        - if <player.inventory.contains_item[bf_setup_wand]>:
            - narrate "You already have the setup wand!"
        - else:
            - give bf_setup_wand
            - playsound <player> sound:block_amethyst_block_step
            - narrate <&6>Wand!
      - case bf_setup_arena_pending:
        - if !<player.inventory.contains_item[bf_setup_wand]>:
            - give bf_setup_wand
        - playsound <player> sound:block_amethyst_block_step
        - wait 2t
        - narrate "Use the <&6>Setup Wand <&f>to select the arena corners."
        - narrate "Left Click <&e>Corner 1"
        - actionbar "Left Click <&e>Corner 1"
        - flag <player> bf_setup:arena_boundary_1
      - case bf_setup_arena_redo:
        - flag <player> bf_setup_procedure_flags.arena:!
        - note remove as:bf_arena
        - inject bf_setup_redo_task
      - case bf_arena_show_item:
        - run bf_show_arena_task
      - case bf_setup_blue_base_pending:
        - narrate "Left Click with the <&6>Setup Wand <&f>to set <&9>blue <&f>forge."
        - actionbar "Click to set<&9> blue <&f>forge."
        - playsound <player> sound:block_amethyst_block_step
        - flag <player> bf_setup:blue_forge
      - case bf_setup_blue_base_redo:
        - flag <player> bf_setup_procedure_flags.blue_base:!
        - flag <cuboid[bf_arena].blocks_flagged[bf.forge.blue]> bf.forge:!
        - note remove as:bf_forge_blue
        - note remove as:bf_blue_spawn
        - modifyblock <location[bf_blue_chest]> air
        - remove <server.spawned_npcs_flagged[bf.shop.blue]>
        - note remove as:bf_blue_chest
        - inject bf_setup_redo_task
      - case bf_setup_red_base_pending:
        - narrate "Left Click with the <&6>Setup Wand <&f>to set <&c>red <&f>forge."
        - actionbar "Click to set<&c> red <&f>forge."
        - playsound <player> sound:block_amethyst_block_step
        - flag <player> bf_setup:red_forge
      - case bf_setup_red_base_redo:
        - flag <player> bf_setup_procedure_flags.red_base:!
        - flag <cuboid[bf_arena].blocks_flagged[bf.forge.red]> bf.forge:!
        - note remove as:bf_forge_red
        - note remove as:bf_red_spawn
        - modifyblock <location[bf_red_chest]> air
        - remove <server.spawned_npcs_flagged[bf.shop.red]>
        - note remove as:bf_red_chest
        - inject bf_setup_redo_task
      - case bf_setup_admin_spawn_pending:
        - flag <player> bf_setup:admin_spawn
        - wait 0.5s
        - actionbar "Set <&6>Admin Spawn"
        - narrate "Left click to set <&6>Admin Spawn."
        - playsound <player> sound:block_amethyst_block_step
      - case bf_setup_admin_spawn_redo:
        - flag <player> bf_setup_procedure_flags.admin_spawn:!
        - note remove as:bf_admin_spawn
        - inject bf_setup_redo_task
      - case bf_setup_lobbies_pending:
        - flag <player> bf_setup:main_lobby
        - wait 0.5s
        - narrate "Left Click <&e>Main Lobby Spawnpoint <&f>location."
        - actionbar "Set <&e>Main Lobby Spawn"
        - playsound <player> sound:block_amethyst_block_step
      - case bf_setup_lobbies_redo:
        - flag <player> bf_setup_procedure_flags.lobbies:!
        - note remove as:bf_main_lobby
        - note remove as:bf_main_lobby_spawn
        - note remove as:bf_pregame_lobby_spawn
        - note remove as:bf_pregame_lobby
        - inject bf_setup_redo_task
      - case bf_setup_signboard_pending:
        - flag <player> bf_setup:signboard
        - playsound <player> sound:block_amethyst_block_step
        - wait 2t
        - narrate "Left Click wall with wand to place the <&e>entry signs"
        - narrate "This must not be in the same area as the Pregame waiting area!"
        - actionbar "Set <&e>Entry Sign"
      - case bf_setup_signboard_redo:
        - flag <player> bf_setup_procedure_flags.signboard:!
        - modifyblock <cuboid[bf_sign_board].blocks[*wall_sign]> air
        - note remove as:bf_sign_board
        - note remove as:bf_spec_sign
        - note remove as:bf_admin_sign
        - note remove as:bf_sign
        - inject bf_setup_redo_task
      - case bf_delete_all:
        - inject bf_delete_all_task
      - case bf_setup_complete:
        - playsound <player> sound:entity_witch_throw
        - wait 8t
        - playsound <player> sound:block_glass_break
      - default:
        - playsound <player> sound:entity_villager_no
        - inventory open d:bf_setup_gui
    on player drops bf_setup_wand permission:dscript.brickfight.manager:
      - determine cancelled

##########################
##         TASKS        ##
##########################

bf_setup_redo_task:
  type: task
  debug: false
  script:
    - playsound <player> sound:entity_player_burp
    - wait 1s
    - narrate <&c>Deleted!
    - actionbar <&c>Deleted!
    - if <player.has_flag[bf_setup_procedure_flags.complete]>:
      - flag <player> bf_setup_procedure_flags.complete:!
    - flag <player> bf_setup:waiting
    - inventory open d:bf_setup_gui

bf_setup_job_complete_task:
  type: task
  debug: false
  script:
    - define keys <script[bf_setup_config].data_key[player_flags].get[bf_setup_procedure_flags]>
    - if <player.flag[bf_setup_procedure_flags].keys.alphabetical> == <[keys].exclude[complete].alphabetical>:
      - flag <player> bf_setup:complete
      - flag <player> bf_setup_procedure_flags.complete
    - inventory open d:bf_setup_gui

bf_delete_all_task:
  type: task
  debug: false
  script:
  - inventory close
  - clickable save:bf_setup_delete_all until:20s:
    - actionbar "<&c>Arena Deleted!"
    - narrate <empty>
    - narrate "<&c>Arena Deleted!"
    - playsound <player> sound:entity_wither_death pitch:2
    - modifyblock <location[bf_blue_chest]> air if:<location[bf_blue_chest].exists>
    - modifyblock <location[bf_red_chest]> air if:<location[bf_red_chest].exists>
    - modifyblock <cuboid[bf_sign_board].blocks[*wall_sign]> air if:<cuboid[bf_sign_board].exists>
    - remove <server.spawned_npcs_flagged[bf.shop]>
    - if <cuboid[bf_arena].blocks_flagged[bf.forge].exists>:
      - flag <cuboid[bf_arena].blocks_flagged[bf.forge]> bf.forge:!
    - flag <player> bf_setup:!
    - flag <player> bf_setup_procedure_flags:!
    - foreach <script[bf_setup_config].data_key[noted_locations]> as:noted_location:
      - note remove as:<[noted_location]> if:<[noted_location].exists>
  - clickable save:bf_setup_abort_option until:20s:
    - narrate <empty>
    - narrate "<&6>Action Aborted"
    - actionbar "<&6>Action Aborted"
    - stop
  - narrate <empty>
  - actionbar "Are you sure?"
  - narrate "Are you sure? This will delete your arena. <&a><element[YES].on_click[<entry[bf_setup_delete_all].command>]>  <&c><element[NO].on_click[<entry[bf_setup_abort_option].command>]>"

bf_show_arena_task:
  type: task
  debug: false
  script:
  - if !<cuboid[bf_arena].exists>:
    - narrate "<&c>Arena does not exist!"
    - stop
  - showfake glowstone <cuboid[bf_arena].outline> d:15s
  - showfake iron_block <location[bf_forge_blue].below> d:15s if:<location[bf_forge_blue].exists>
  - showfake iron_block <location[bf_forge_red].below> d:15s if:<location[bf_forge_red].exists>
  - showfake white_stained_glass <cuboid[bf_sign_board].blocks[*wall_sign]> d:15s if:<cuboid[bf_sign_board].exists>
  - showfake copper_block <cuboid[bf_pregame_lobby].outline> d:15s if:<cuboid[bf_pregame_lobby].exists>
  - showfake copper_block <location[bf_pregame_lobby_spawn].below> d:15s if:<location[bf_pregame_lobby_spawn].exists>
  - showfake <cuboid[bf_main_lobby].outline> diamond_block d:15s if:<cuboid[bf_main_lobby].exists>
  - showfake <location[bf_main_lobby_spawn].below> diamond_block d:15s if:<location[bf_main_lobby_spawn].exists>
  - playsound <player> sound:block_amethyst_block_step
  - narrate "<&a>Showing Boundaries"
##########################
##      PROCEDURES      ##
##########################

bf_setup_arena_proc:
  type: procedure
  debug: false
  script:
  - if <player.has_flag[bf_setup_procedure_flags.arena]>:
    - determine bf_setup_arena_complete
  - else:
    - determine bf_setup_arena_pending

bf_setup_arena_redo_proc:
  type: procedure
  debug: false
  script:
  - if <player.has_flag[bf_setup_procedure_flags.arena]>:
    - determine bf_setup_arena_redo
  - else:
    - determine air

bf_setup_blue_base_proc:
  type: procedure
  debug: false
  script:
  - if <player.has_flag[bf_setup_procedure_flags.blue_base]>:
    - determine bf_setup_blue_base_complete
  - if <player.has_flag[bf_setup_procedure_flags.arena]> && !<player.has_flag[bf_setup_procedure_flags.blue_base]>:
    - determine bf_setup_blue_base_pending
  - if !<player.has_flag[bf_setup_procedure_flags.arena]>:
    - determine bf_setup_blue_base_prohibited

bf_setup_blue_base_redo_proc:
  type: procedure
  debug: false
  script:
  - if <player.has_flag[bf_setup_procedure_flags.blue_base]>:
    - determine bf_setup_blue_base_redo
  - else:
    - determine air

bf_setup_red_base_proc:
  type: procedure
  debug: false
  script:
  - if <player.has_flag[bf_setup_procedure_flags.red_base]>:
    - determine bf_setup_red_base_complete
  - if <player.has_flag[bf_setup_procedure_flags.blue_base]> && !<player.has_flag[bf_setup_procedure_flags.red_base]>:
    - determine bf_setup_red_base_pending
  - if !<player.has_flag[bf_setup_procedure_flags.blue_base]>:
    - determine bf_setup_red_base_prohibited

bf_setup_red_base_redo_proc:
  type: procedure
  debug: false
  script:
  - if <player.has_flag[bf_setup_procedure_flags.red_base]>:
    - determine bf_setup_red_base_redo
  - else:
    - determine air

bf_setup_admin_spawn_proc:
  type: procedure
  debug: false
  script:
  - if <player.has_flag[bf_setup_procedure_flags.admin_spawn]>:
    - determine bf_setup_admin_spawn_complete
  - if <player.has_flag[bf_setup_procedure_flags.red_base]> && !<player.has_flag[bf_setup_procedure_flags.admin_spawn]>:
    - determine bf_setup_admin_spawn_pending
  - if !<player.has_flag[bf_setup_procedure_flags.red_base]>:
    - determine bf_setup_admin_spawn_prohibited

bf_setup_admin_spawn_redo_proc:
  type: procedure
  debug: false
  script:
  - if <player.has_flag[bf_setup_procedure_flags.admin_spawn]>:
    - determine bf_setup_admin_spawn_redo
  - else:
    - determine air

bf_setup_chest_facing_proc:
  type: procedure
  debug: false
  script:
    - if <player.location.yaw.simple.advanced_matches[north]>:
      - determine 0,0,1
    - if <player.location.yaw.simple.advanced_matches[south]>:
      - determine 0,0,-1
    - if <player.location.yaw.simple.advanced_matches[east]>:
      - determine -1,0,0
    - if <player.location.yaw.simple.advanced_matches[west]>:
      - determine 1,0,0

bf_setup_lobbies_proc:
  type: procedure
  debug: false
  script:
  - if <player.has_flag[bf_setup_procedure_flags.lobbies]>:
    - determine bf_setup_lobbies_complete
  - if <player.has_flag[bf_setup_procedure_flags.admin_spawn]> && !<player.has_flag[bf_setup_procedure_flags.lobbies]>:
    - determine bf_setup_lobbies_pending
  - if !<player.has_flag[bf_setup_procedure_flags.admin_spawn]>:
    - determine bf_setup_lobbies_prohibited

bf_setup_lobbies_redo_proc:
  type: procedure
  debug: false
  script:
  - if <player.has_flag[bf_setup_procedure_flags.lobbies]>:
    - determine bf_setup_lobbies_redo
  - else:
    - determine air

bf_setup_signboard_proc:
  type: procedure
  debug: false
  script:
  - if <player.has_flag[bf_setup_procedure_flags.signboard]>:
    - determine bf_setup_signboard_complete
  - if <player.has_flag[bf_setup_procedure_flags.lobbies]> && !<player.has_flag[bf_setup_procedure_flags.signboard]>:
    - determine bf_setup_signboard_pending
  - if !<player.has_flag[bf_setup_procedure_flags.lobbies]>:
    - determine bf_setup_signboard_prohibited

bf_setup_signboard_redo_proc:
  type: procedure
  debug: false
  script:
  - if <player.has_flag[bf_setup_procedure_flags.signboard]>:
    - determine bf_setup_signboard_redo
  - else:
    - determine air

bf_setup_complete_proc:
  type: procedure
  debug: false
  script:
    - if <player.has_flag[bf_setup_procedure_flags.complete]>:
      - determine bf_setup_complete
    - else:
      - determine air

##########################
##        ITEMS         ##
##########################

bf_setup_wand:
  type: item
  debug: false
  material: blaze_rod
  display name: <&6>Brick Fight Setup Wand
  lore:
    - <&7>sneak right-click to open menu
  mechanisms:
    hides: all
  enchantments:
    - vanishing_curse:1

bf_arena_show_item:
    type: item
    debug: false
    material: spyglass
    display name: <&6>Show Arena

bf_setup_arena_pending:
  type: item
  debug: false
  material: lime_stained_glass_pane
  display name: Set up Arena Boundaries
  mechanisms:
    enchantments: mending,1
    hides: all
  lore:
    - <&7>Click to start

bf_setup_arena_complete:
  type: item
  debug: false
  material: green_stained_glass_pane
  display name: <&a>Set up Arena Boundaries
  lore:
    - <&a>Complete!

bf_setup_arena_redo:
  type: item
  debug: false
  material: totem_of_undying
  display name: Redo Arena Boundaries
  lore:
    - <&7>Click to Redo

bf_setup_blue_base_prohibited:
  type: item
  debug: false
  material: red_stained_glass_pane
  display name: Set up Blue Base
  lore:
    - <&7><&lt>--Set up Arena First

bf_setup_blue_base_pending:
  type: item
  debug: false
  material: lime_stained_glass_pane
  mechanisms:
    enchantments: mending,1
    hides: all
  display name: Set up Blue Base
  lore:
    - <&7>Click to start

bf_setup_blue_base_complete:
  type: item
  debug: false
  material: green_stained_glass_pane
  display name: <&a>Set up Blue Base
  lore:
    - <&a>Complete!

bf_setup_blue_base_redo:
  type: item
  debug: false
  material: totem_of_undying
  display name: Redo Blue Base
  lore:
    - <&7>Click to Redo

bf_setup_red_base_prohibited:
  type: item
  debug: false
  material: red_stained_glass_pane
  display name: Set up Red Base
  lore:
    - <&7><&lt>--Set up Blue Base First

bf_setup_red_base_pending:
  type: item
  debug: false
  material: lime_stained_glass_pane
  mechanisms:
    enchantments: mending,1
    hides: all
  display name: Set up Red Base
  lore:
    - <&7>Click to start

bf_setup_red_base_complete:
  type: item
  debug: false
  material: green_stained_glass_pane
  display name: <&a>Set up Red Base
  lore:
    - <&a>Complete!

bf_setup_red_base_redo:
  type: item
  debug: false
  material: totem_of_undying
  display name: Redo Red Base
  lore:
    - <&7>Click to Redo

bf_setup_admin_spawn_prohibited:
  type: item
  debug: false
  material: red_stained_glass_pane
  display name: Set up Admin Spawn
  lore:
    - <&7><&lt>--Set up Red Base First

bf_setup_admin_spawn_pending:
  type: item
  debug: false
  material: lime_stained_glass_pane
  mechanisms:
    enchantments: mending,1
    hides: all
  display name: Set up Admin Spawn
  lore:
    - <&7>Click to start

bf_setup_admin_spawn_complete:
  type: item
  debug: false
  material: green_stained_glass_pane
  display name: <&a>Set up Admin Spawn
  lore:
    - <&a>Complete!

bf_setup_admin_spawn_redo:
  type: item
  debug: false
  material: totem_of_undying
  display name: Redo Admin Spawn
  lore:
    - <&7>Click to Redo
bf_setup_lobbies_prohibited:
  type: item
  debug: false
  material: red_stained_glass_pane
  display name: Set up Lobbies
  lore:
    - <&7><&lt>--Set up Admin Spawn First

bf_setup_lobbies_pending:
  type: item
  debug: false
  material: lime_stained_glass_pane
  mechanisms:
    enchantments: mending,1
    hides: all
  display name: Set up Lobbies
  lore:
    - <&7>Click to start

bf_setup_lobbies_complete:
  type: item
  debug: false
  material: green_stained_glass_pane
  display name: <&a>Set up Lobbies
  lore:
    - <&a>Complete!

bf_setup_lobbies_redo:
  type: item
  debug: false
  material: totem_of_undying
  display name: Redo Lobbies
  lore:
    - <&7>Click to Redo

bf_setup_signboard_prohibited:
  type: item
  debug: false
  material: red_stained_glass_pane
  display name: Set up Signboard
  lore:
    - <&7><&lt>--Set up Lobbies First

bf_setup_signboard_pending:
  type: item
  debug: false
  material: lime_stained_glass_pane
  mechanisms:
    enchantments: mending,1
    hides: all
  display name: Set up Signboard
  lore:
    - <&7>Click to start

bf_setup_signboard_complete:
  type: item
  debug: false
  material: green_stained_glass_pane
  display name: <&a>Set up Main Lobby Signboard
  lore:
    - <&a>Complete!

bf_setup_signboard_redo:
  type: item
  debug: false
  material: totem_of_undying
  display name: Redo Signboard
  lore:
    - <&7>Click to Redo

bf_setup_complete:
  type: item
  debug: false
  material: nether_star
  display name: <&a>Set Up Complete!!
  lore:
    - <&f>Enjoy Brick Fight!
    - <&d>An ObiWorld Original Minigame
    - <&d>with additional credit to <&5>LG_Legacy

bf_delete_all:
  type: item
  debug: false
  material: barrier
  display name: <&c>Delete All
  lore:
    - <&7>Deletes all your hard work!

##########################
##          GUI         ##
##########################

bf_setup_gui:
  type: inventory
  debug: false
  inventory: chest
  gui: true
  slots:
  - [<proc[bf_setup_arena_proc]>] [<proc[bf_setup_blue_base_proc]>] [<proc[bf_setup_red_base_proc]>] [<proc[bf_setup_admin_spawn_proc]>] [<proc[bf_setup_lobbies_proc]>] [<proc[bf_setup_signboard_proc]>] [] [] []
  - [<proc[bf_setup_arena_redo_proc]>] [<proc[bf_setup_blue_base_redo_proc]>] [<proc[bf_setup_red_base_redo_proc]>] [<proc[bf_setup_admin_spawn_redo_proc]>] [<proc[bf_setup_lobbies_redo_proc]>] [<proc[bf_setup_signboard_redo_proc]>] [] [] []
  - [bf_setup_wand] [bf_arena_show_item] [] [] [] [] [] [<proc[bf_setup_complete_proc]>] [bf_delete_all]

##END OF SETUP SCRIPT

##########################
##       THE END        ##
##########################
